#include <stdlib.h>
#include <stdio.h>
#include <vga.h>
#include <vgagl.h>
#include <string.h>

#define VWIDTH 640
#define VHEIGHT 480

#define CHARWIDTH 16
#define CHARHEIGHT 16

unsigned char *vbuf;

void disp(void)
{
    int pageoffset = 0;

    vga_setdisplaystart(0);
        vga_copytoplanar16(vbuf, WIDTH,
                           pageoffset, 80, VWIDTH, VHEIGHT);

        vga_setdisplaystart(pageoffset);

    for (;;){
        if (vga_getkey()) 
            break;
    }
}

int fontload(char *fontname)
{
    FILE *fp;
    char buf[128];
    char c_buf[CHARWIDTH/4], c_num[CHARWIDTH];
    int i,j;
    int fontnum=0;
    int offset = 0;

    fp=fopen(fontname,"r");
    if (fp==NULL){
        perror("no 16x16 dot bdf font file\n");
        exit (0);
    }
    while (! fgets(buf, 80, fp)==NULL){
	if (!strncmp("BITMAP", buf, 6)) {
            if (fontnum>=(VWIDTH/CHARWIDTH*VHEIGHT/CHARHEIGHT)) return 0;
            fontnum++;
            for (i=0; i<CHARHEIGHT; i++){
                fgets(buf, 80, fp);
                for (j=0; j<(CHARWIDTH/4); j++){
                    if (buf[j] >='0' && buf[j] <='9') c_buf[j]=buf[j]-'0';
                    if (buf[j] >='a' && buf[j] <='f') c_buf[j]=buf[j]-'a'+10;
                    if (buf[j] >='A' && buf[j] <='F') c_buf[j]=buf[j]-'A'+10;
                };
                for (j=0; j<(CHARWIDTH/4); j++){
                    c_num[j*4]   = (c_buf[j]>>3);
                    c_num[j*4+1] = (c_buf[j]>>2)%2;
                    c_num[j*4+2] = (c_buf[j]>>1)%2;
                    c_num[j*4+3] = (c_buf[j])%2;
                }
                for (j=0; j<CHARWIDTH; j++){
                    if (c_num[j]>0) vbuf[offset+i*VWIDTH+j]=15;
                    if (c_num[j]==0) vbuf[offset+i*VWIDTH+j]=0;
                }
            }
            offset+=CHARWIDTH;
            if ((fontnum%(VWIDTH/CHARWIDTH))==0) offset+=640*(CHARHEIGHT-1);
        }
    }
    return 0;
}

int main(int argc, char **argv)
{
    char *fontname;

    fontname = argv[1];
    vga_init();

    vbuf = malloc(VWIDTH * VHEIGHT);
    gl_setcontextvirtual(VWIDTH, VHEIGHT, 1, 8, vbuf);

    vga_setmode(G640x480x16);
/*    gl_setrgbpalette(); */
    vga_clear();

    fontload(fontname);
    disp();

    vga_setmode(TEXT);
    exit(0);
}
