#include <stdio.h>
#include <string.h>
#include "vga.h"

static void vgadraw(int mode)
{
    int xmax, ymax, i, j;

    vga_setmode(mode);
    vga_screenoff();

    xmax = vga_getxdim() - 1;
    ymax = vga_getydim() - 1;

    vga_setcolor(vga_white());
    vga_drawline(0, 0, xmax, 0);
    vga_setegacolor(1);
    vga_drawline(xmax, 0, xmax, ymax);
    vga_setegacolor(2);
    vga_drawline(xmax, ymax, 0, ymax);
    vga_setegacolor(3);
    vga_drawline(0, ymax, 0, 0);

    for (i = 0; i <= 639; i++) {
	for (j = 0; j <= 479; j++) {
	    vga_setegacolor((i+j)%16);
	    vga_drawpixel(i, j);
	}
    }

    vga_screenon();
    vga_getch();
    vga_setmode(TEXT);
}

int main(void)
{
    int mode;

    vga_init();
    mode = 4;
    if (vga_hasmode(mode))
	vgadraw(mode);
    else {
	printf("Error: VGA 640x480x16 mode not supported\n");
	exit(-1);
    }
    return 0;
}
