#include <stdio.h>
#include <string.h>
#include "vga.h"

static int CharWide=16;
static int CharHight=16;
extern int draw_char(int cursol_x, int cursol_y, int color);

static void vgadraw(int mode)
{
    int xmax, ymax, i;

    vga_setmode(mode);
    vga_screenoff();

    xmax = vga_getxdim() - 1;
    ymax = vga_getydim() - 1;

    vga_setcolor(vga_white());
    vga_drawline(0, 0, xmax, 0);
    vga_setegacolor(1);
    vga_drawline(xmax, 0, xmax, ymax);
    vga_setegacolor(2);
    vga_drawline(xmax, ymax, 0, ymax);
    vga_setegacolor(3);
    vga_drawline(0, ymax, 0, 0);

    for (i = 0; i < 16; i++) {
        draw_char(i, i, i);

        vga_screenon();
    }

    vga_getch();
    vga_setmode(TEXT);
}

int draw_char(int cursol_x, int cursol_y, int color)
{
    int i,j;

    for (i = 0; i < CharHight; i++){
        vga_setegacolor(0);
        vga_drawline(cursol_x*CharWide, cursol_y*CharHight+i, 
                     (cursol_x+1)*CharWide-1, cursol_y*CharHight+i);
        vga_setegacolor(color);
        for (j = 0; j < CharWide; j++){
            vga_drawpixel(cursol_x*CharWide + j, cursol_y*CharHight + i);
        }
    }
    return 0;
}

int main(void)
{
    int mode;

    vga_init();
    mode = 4;
    if (vga_hasmode(mode))
	vgadraw(mode);
    else {
	printf("Error: VGA 640x480x16 mode not supported\n");
	exit(-1);
    }
    return 0;
}
